;--------------------------------------------------------------------
FXD2416U		
 ;GLOBAL		FXD2416U

; RCALL							FXD2408U
	MOVFF		Reminder+0,Reminder+1
	CLRF		Reminder+0,BANKED
		RETLW 0x00

D2416_BGT1

	CPFSEQ		A_Arg+0,BANKED
 BRA							D2416_AGTB
	MOVFF		A_Arg+1,A_Arg+0
	MOVFF		A_Arg+2,A_Arg+1
 RCALL							FXD1616U
		
	MOVFF		A_Arg+1,A_Arg+2
	MOVFF		A_Arg+0,A_Arg+1
	CLRF		A_Arg+0,BANKED
		RETLW 0x00




D2416_AGTB
	MOVFF		A_Arg+2,A_Arg+3
	MOVFF		A_Arg+1,A_Arg+2
	MOVFF		A_Arg+0,A_Arg+1
	CLRF		A_Arg+0,BANKED

	MOVFF		A_Arg+0,Math_Work+0
	MOVFF		A_Arg+1,Math_Work+1
	MOVFF		A_Arg+2,Math_Work+2
	MOVFF		A_Arg+3,Math_Work+3

	MOVLW	0x02			; set loop count
	MOVWF	A_Exp,BANKED

	MOVLW	0x01
	MOVWF	Z_Arg+0,BANKED

	BTFSC		B_Arg+0,MSB,BANKED
 BRA						D2416U_NrmOk

 RCALL						D_Get_NRmd		; get normalization factor
	MOVWF	Z_Arg+0,BANKED

	MULWF	B_Arg+1,BANKED
	MOVF		B_Arg+0,W,BANKED
	MOVFF		PRODL,B_Arg+1
	MOVFF		PRODH,B_Arg+0

	MULWF	Z_Arg+0,BANKED
	MOVF		PRODL,W,BANKED
	ADDWF	B_Arg+0,F,BANKED

	MOVF		Z_Arg+0,W,BANKED
	MULWF	A_Arg+3,BANKED
	MOVFF		PRODL,Math_Work+3
	MOVFF		PRODH,Math_Work+2

	MULWF	A_Arg+1,BANKED
	MOVFF		PRODL,Math_Work+1
	MOVFF		PRODH,Math_Work+0

	MULWF	A_Arg+2,BANKED
	MOVF		PRODL,W
	ADDWF	Math_Work+2,F,BANKED
	MOVF		PRODH,W
	ADDWF	Math_Work+1,F,BANKED

D2416U_NrmOk

	BCF		_C
	CLRF		TBLPTRH
	RLCF		B_Arg+0,W,BANKED
	RLCF		TBLPTRH,F,BANKED
	ADDLW	LOW (RecipTable+1)	; access reciprocal table
	MOVWF	TBLPTRL
	MOVLW	HIGH (RecipTable)
	ADDWFC	TBLPTRH,F
		TBLRD *-

D2416U_Loop

	MOVFF		Math_Work+0,A_Arg+0
	MOVFF		Math_Work+1,A_Arg+1

 RCALL						FXD1608U2; estimate quotient digit

	BTFSS		A_Arg+0,LSB,BANKED
 BRA						D2416U_Q_Test
	SETF		A_Arg+1,BANKED
	MOVFF		Math_Work+1,Reminder+0
	MOVF		B_Arg+0,W,BANKED
	ADDWF	Reminder+0,F,BANKED

	BTFSC		_C
 BRA						D2416U_Q_Ok

D2416U_Q_Test

	MOVF		A_Arg+1,W,BANKED		; test
	MULWF	B_Arg+1,BANKED

	MOVF		PRODL,W
	SUBWF	Math_Work+2,W,BANKED
	MOVF		PRODH,W
	SUBWFB	Reminder+0,W,BANKED

	BTFSC		_C
 BRA						D2416U_Q_Ok

	DECF		A_Arg+1,F,BANKED

	MOVF		B_Arg+0,W,BANKED
	ADDWF	Reminder+0,F,BANKED

	BTFSC		_C
 BRA						D2416U_Q_Ok

	MOVF		A_Arg+1,W,BANKED
	MULWF	B_Arg+1,BANKED

	MOVF		PRODL,W
	SUBWF	Math_Work+2,W,BANKED
	MOVF		PRODH,W
	SUBWFB	Reminder+0,W,BANKED

	BTFSS		_C
	DECF		A_Arg+1,F,BANKED

D2416U_Q_Ok

	MOVFF		A_Arg+1,Z_Arg+1

	MOVF		A_Arg+1,W,BANKED
	MULWF	B_Arg+1,BANKED
	MOVF		PRODL,W
	SUBWF	Math_Work+2,F,BANKED
	MOVF		PRODH,W
	SUBWFB	Math_Work+1,F,BANKED

	MOVF		A_Arg+1,W,BANKED
	MULWF	B_Arg+0,BANKED
	MOVF		PRODL,W
	SUBWF	Math_Work+1,F,BANKED
	MOVF		PRODH,W
	SUBWFB	Math_Work+0,F,BANKED

	BTFSS		Math_Work+0,MSB,BANKED		; test
 BRA						D2416_Q_Ok
	DECF		Z_Arg+1,F,BANKED

	MOVF		B_Arg+1,W,BANKED
	ADDWF	Math_Work+2,F,BANKED
	MOVF		B_Arg+0,W,BANKED
	ADDWFC	Math_Work+1,F,BANKED

D2416_Q_Ok

	DCFSNZ	A_Exp,F,BANKED	; is loop done?
 BRA						D2416_FixRem

	MOVFF		Z_Arg+1,Z_Arg+2

	MOVFF		Math_Work+1,Math_Work+0
	MOVFF		Math_Work+2,Math_Work+1
	MOVFF		Math_Work+3,Math_Work+2

 BRA						D2416U_Loop		

D2416_FixRem
	MOVFF		Math_Work+1,Reminder+0
	MOVFF		Math_Work+2,Reminder+1

	MOVLW		0x01
	
	CPFSGT		Z_Arg+0,BANKED
 BRA						D2416_RemOk

	RRNCF		Z_Arg+0,W,BANKED
	MOVWF	B_Arg+0,BANKED
 RCALL						DGETNRMD

	MULWF	Math_Work+2,BANKED
	MOVFF		PRODH,Reminder+1
	MULWF	Math_Work+1,BANKED
	MOVF		PRODL,W,BANKED
	ADDWF	Reminder+1,F,BANKED
	MOVFF		PRODH,Reminder+0

D2416_RemOk

	CLRF		A_Arg+0,BANKED
	MOVFF		Z_Arg+1,A_Arg+2
	MOVFF		Z_Arg+2,A_Arg+1

 		RETLW 0x00
;;---------------------------------------------------------
D_Get_NRmd
	MOVLW	0x10
	CPFSLT	B_Arg+0,BANKED
 bra						D_Get_NRmdH
D_Get_NRmdL
	BTFSC		B_Arg+0,3,BANKED
		RETLW		0x10		
	BTFSC		B_Arg+0,2,BANKED
		RETLW		0x20		
	BTFSC		B_Arg+0,1,BANKED
		RETLW		0x40
	BTFSC		B_Arg+0,0,BANKED
		RETLW		0x80
D_Get_NRmdH
	BTFSC		B_Arg+0,6,BANKED
		RETLW		0x02		
	BTFSC		B_Arg+0,5,BANKED
		RETLW		0x04		
	BTFSC		B_Arg+0,4,BANKED
		RETLW		0x08

;----------------------------------------------------------------------------------------------
		
