;Include for: PCPWM_3F_4431.asm
;PCPWM	code	
;SpeedCalc	;     100 
; #include Proj_Dir\PCPWM_3F\SpeedCalc.inc	;  -   

	movf	PCPWM_SpeedReal,W,BANKED	;    -   
	mullw	0x3 ;    ;   

 	movf	PCPWM_MaxSpdIndx,W,BANKED	;   -    
 bz		MaxSpd_100 ;  - 100  

	dcfsnz	WREG,W,ACCESS	
 bra	MaxSpd_200 ;  - 200  

	dcfsnz	WREG,W,ACCESS	
 bra	MaxSpd_400 ;  - 400  

; 19/01/2020   -  .
;	dcfsnz	WREG,W,ACCESS	
; bra	MaxSpd_800 ;  - 800  


;;   -   
;Tab16Load	macro	A_Arg,TableAdr;    16 
 Tab16Load	PCPWM_MaxSpdIndx,Table_Simples;    16 

; movff	PCPWM_SpeedReal,PCPWM_SpdCopy	;   
 FXMTab1608U PCPWM_ML_Work,BANKED,PCPWM_SpeedReal,BANKED;D_Arg,A1D,A_Arg,A1A;16     8   
;;  () 8    16     = 24    .
;;   32   
;

Sim_Spd_Move	;
 bcf		INTCON,GIEL,ACCESS		;    
	movff24	PCPWM_ML_Work,BufProduct;    
 bsf		INTCON,GIEL,ACCESS		;    


 #ifdef	PCPWM_12b ; 12   
 movf	PCPWM_Amp,W,BANKED	;   V/F
	mulwf	PCPWM_SpeedReal,BANKED;       V/F
 movff16	PRODL,PCPWM_ML_Work+2	;    

;   =    
	rlcf	PRODL,W,ACCESS;   
	movwf	PCPWM_ML_Work+2,BANKED	;
	rlcf	PRODH,W,ACCESS	;  
	movwf	PCPWM_ML_Work+3,BANKED	;
		bc		MaxAmp12	;   -    
 movf	PCPWM_VFStart,W,BANKED	;   V/F
	mulwf	PCPWM_VFStart,BANKED;        
  Add16	PCPWM_ML_Work+2,BANKED,PRODL,ACCESS
		bnc	NoLim12		;   ? 
MaxAmp12
	setf	PCPWM_ML_Work+2,BANKED	;  
	setf	PCPWM_ML_Work+3,BANKED	; 
NoLim12	;   16  12
;Con16v12	MACRO Destin,AdrD,Source,AdrS	;  16  12 
 Con16v12	PCPWM_ML_Work+0,BANKED,PCPWM_ML_Work+2,BANKED	; 

; 02/02/2020 ****   3 
	movff16	PCPWM_ML_Work+0,PCPWM_ML_Work+2;    3H
	Sub16L	PCPWM_ML_Work+2,BANKED,d'1638'	;    3 
		bc		NonZeroAmp3	;  
;   (0|0xFFF)  2/5= 1638   3  = 0.
	clrf	PCPWM_ML_Work+2,BANKED	;  3    V/F
	clrf	PCPWM_ML_Work+3,BANKED	;  3    V/F
		bra		DoneAmp3
NonZeroAmp3	
;     (1638|4095-1638=0|2457)*6.6943 = (0|16448).
;    16b*16b=32/16b    6.6943*256=1713.74  .
;   SynMulBuf+2 : PCPWM_AmpSin3+0 : PCPWM_AmpSin3+1     
;									PCPWM_ML_Work+4	: PCPWM_ML_Work+5					
	movlw	low(d'1713')	;   
  mulwf		PCPWM_ML_Work+2,BANKED	; 
;	movff	PRODL,SynMulBuf+2	;  
	movff	PRODH,PCPWM_ML_Work+4;  
	movlw	high(d'1713')	;   
  mulwf		PCPWM_ML_Work+3,BANKED	; 
	movff	PRODL,PCPWM_ML_Work+5	;  ,    
	movlw	low(d'1713')	;    
   mulwf	PCPWM_ML_Work+3,BANKED	; 
; ArgB,A1B,ArgA,A1A	;   -  ;   B=B+A 
  Add16	PCPWM_ML_Work+4,BANKED,PRODL,ACCESS;    
	movlw	high(d'1713')	;     
  mulwf		PCPWM_ML_Work+2,BANKED	; 
  Add16	PCPWM_ML_Work+4,BANKED,PRODL,ACCESS;    
;  PCPWM_ML_Work+4   (0|16440) .
DoneAmp3

;          
 bcf		INTCON,GIEL,ACCESS		;    
	movff16	PCPWM_ML_Work+0,PCPWM_AmpSin;    
	movff16	PCPWM_ML_Work+4,PCPWM_AmpSin3+0	;3     
 bsf		INTCON,GIEL,ACCESS		;    

 #else ; 8 bit
 movf	PCPWM_Amp,W,BANKED	;   V/F 

	mulwf	PCPWM_SpeedReal,BANKED;       V/F

	clrf	PCPWM_ML_Work+2,BANKED	;   
	rrcf	PCPWM_VFStart,W,BANKED	;  
	rrcf	PCPWM_ML_Work+2,F,BANKED;  16 
	rrcf	WREG,W,ACCESS			;  
	rrcf	PCPWM_ML_Work+2,F,BANKED;   
	andlw	b'00111111'				;    16  - 
; =  , = 
	movwf	PCPWM_ML_Work+3,BANKED	;
		;movwf	PCPWM_SpdCopy,BANKED	; 
 Add16	PCPWM_ML_Work+2,BANKED,PRODL,ACCESS
		bc	MaxLimit		;   ? 
;	bcf	_C	;    
	rlcf	PCPWM_ML_Work+2,F,BANKED	;    * 2
	rlcf	PCPWM_ML_Work+3,W,BANKED	;    * 2
		btfsc	_C;	MaxLimit		;   ? -   ,     .
MaxLimit	
	setf	WREG,ACCESS			;     
 	movwf	PCPWM_AmpSin,BANKED	;      
#endif


 

 ;movff	PCPWM_AmpSin,PCPWM_AmpSinCopy	;   

		return	;     - .

MaxSpd_100
 Extern	Simples_100
	Add16L	PRODL,ACCESS,Simples_100	;
		bra	Sim_Spd_Done



MaxSpd_200
 Extern	Simples_200
	Add16L	PRODL,ACCESS,Simples_200	;
		bra	Sim_Spd_Done

; 02/02/2020   -  
MaxSpd_400
 Extern	Simples_400
	Add16L	PRODL,ACCESS,Simples_400	;
		bra	Sim_Spd_Done

; 19/01/2020   -  .
;MaxSpd_800
; Extern	Simples_800
;
;	Add16L	PRODL,ACCESS,Simples_800	;
Sim_Spd_Done
	movff16	PRODL,TBLPTRL		;
	clrf	TBLPTRU,ACCESS		;   
	TBLRD*+
	movff	TABLAT,PCPWM_ML_Work+0	;
	TBLRD*+
	movff	TABLAT,PCPWM_ML_Work+1	;
	TBLRD*+
	movff	TABLAT,PCPWM_ML_Work+2	;
		bra	Sim_Spd_Move