;Include for: PCPWM_3F_4431.asm
;PCPWM	code	
;SpeedCalc	;     100 
; #include Proj_Dir\PCPWM_3F\SpeedCalc.inc	;  -   
;     0x41-0x4d  ,  - .
;   -     256  24    (0  1 PCPWM_MaxSpdIndx),
;    -   .
;    8           .
;   - -        

;       .
;       140   290 .
;   8    8  ,   
; 8   ,    -   0xFF
;     .

	movf	PCPWM_SpeedReal,W,BANKED	;    -   
	mullw	0x3 ;    ;   

 	movf	PCPWM_MaxSpdIndx,W,BANKED	;   -    
 bz		MaxSpd_100 ;  - 100  
	dcfsnz	WREG,W,ACCESS	
 bra	MaxSpd_200 ;  - 200  
	dcfsnz	WREG,W,ACCESS	
 bra	MaxSpd_400 ;  - 400  

; 19/01/2020   -  .
;	dcfsnz	WREG,W,ACCESS	
; bra	MaxSpd_800 ;  - 800  


;;   -   
;Tab16Load	macro	A_Arg,TableAdr;    16 
 Tab16Load	PCPWM_MaxSpdIndx,Table_Simples;    16 

; movff	PCPWM_SpeedReal,PCPWM_SpdCopy	;   
 FXMTab1608U PCPWM_ML_Work,BANKED,PCPWM_SpeedReal,BANKED;D_Arg,A1D,A_Arg,A1A;16     8   
;;  () 8    16     = 24    .
;;   32   
;

Sim_Spd_Move	;
 bcf		INTCON,GIEL,ACCESS		;    
	movff24	PCPWM_ML_Work,BufProduct;    
 bsf		INTCON,GIEL,ACCESS		;    


 #ifdef	PCPWM_12b ; 12   
 movf	PCPWM_Amp,W,BANKED	;   V/F
	mulwf	PCPWM_SpeedReal,BANKED;       V/F
 movff16	PRODL,PCPWM_ML_Work+2	;    

;   =    
	rlcf	PRODL,W,ACCESS;   
	movwf	PCPWM_ML_Work+2,BANKED	;
	rlcf	PRODH,W,ACCESS	;  
	movwf	PCPWM_ML_Work+3,BANKED	;
		bc		MaxAmp12	;   -    
 movf	PCPWM_VFStart,W,BANKED	;   V/F
	mulwf	PCPWM_VFStart,BANKED;        
  Add16	PCPWM_ML_Work+2,BANKED,PRODL,ACCESS
		bnc	NoLim12		;   ? 
MaxAmp12
	setf	PCPWM_ML_Work+2,BANKED	;  
	setf	PCPWM_ML_Work+3,BANKED	; 
NoLim12	;   16  12
;Con16v12	MACRO Destin,AdrD,Source,AdrS	;  16  12 
 Con16v12	PCPWM_ML_Work+0,BANKED,PCPWM_ML_Work+2,BANKED	; 
;          
 bcf		INTCON,GIEL,ACCESS		;    
	movff16	PCPWM_ML_Work+0,PCPWM_AmpSin;    
 bsf		INTCON,GIEL,ACCESS		;    

 #else ; 8 bit
 movf	PCPWM_Amp,W,BANKED	;   V/F,      FF

	mulwf	PCPWM_SpeedReal,BANKED;       V/F

	clrf	PCPWM_ML_Work+2,BANKED	;   
	rrcf	PCPWM_VFStart,W,BANKED	;  
	rrcf	PCPWM_ML_Work+2,F,BANKED;  16 
	rrcf	WREG,W,ACCESS			;  
	rrcf	PCPWM_ML_Work+2,F,BANKED;   
	andlw	b'00111111'				;    16  - 
; =  , = 
	movwf	PCPWM_ML_Work+3,BANKED	;
		;movwf	PCPWM_SpdCopy,BANKED	; 
 Add16	PCPWM_ML_Work+2,BANKED,PRODL,ACCESS
		bc	MaxLimit		;   ? 
;	bcf	_C	;    
	rlcf	PCPWM_ML_Work+2,F,BANKED	;    * 2
	rlcf	PCPWM_ML_Work+3,W,BANKED	;    * 2
		btfsc	_C;	MaxLimit		;   ? -   ,     .
MaxLimit	
	setf	WREG,ACCESS			;     
 	movwf	PCPWM_AmpSin,BANKED	;      
#endif


 

 ;movff	PCPWM_AmpSin,PCPWM_AmpSinCopy	;   

		return	;     - .

MaxSpd_100
 Extern	Simples_100
	Add16L	PRODL,ACCESS,Simples_100	;
		bra	Sim_Spd_Done
MaxSpd_200
 Extern	Simples_200
	Add16L	PRODL,ACCESS,Simples_200	;
		bra	Sim_Spd_Done
MaxSpd_400
 Extern	Simples_400
	Add16L	PRODL,ACCESS,Simples_400	;
		bra	Sim_Spd_Done
; 19/01/2020   -  .
;MaxSpd_800
; Extern	Simples_800
;
;	Add16L	PRODL,ACCESS,Simples_800	;
Sim_Spd_Done
	movff16	PRODL,TBLPTRL		;
	clrf	TBLPTRU,ACCESS		;   
	TBLRD*+
	movff	TABLAT,PCPWM_ML_Work+0	;
	TBLRD*+
	movff	TABLAT,PCPWM_ML_Work+1	;
	TBLRD*+
	movff	TABLAT,PCPWM_ML_Work+2	;
		bra	Sim_Spd_Move